from pathlib import Path

from pydantic_settings import BaseSettings


class Settings(BaseSettings):
    """Application settings."""

    # API settings
    API_V1_STR: str = "/api/v1"
    PROJECT_NAME: str = "Generic REST API"

    # Database settings
    DB_DIR: Path = Path("/app/storage/db")

    class Config:
        case_sensitive = True
        env_file = ".env"


settings = Settings()

# Ensure DB directory exists
settings.DB_DIR.mkdir(parents=True, exist_ok=True)
